diff --git a/src/gui/kernel/qplatformwindow.cpp b/src/gui/kernel/qplatformwindow.cpp
index 5062bd1e77..4d5cf6c889 100644
--- a/src/gui/kernel/qplatformwindow.cpp
+++ b/src/gui/kernel/qplatformwindow.cpp
@@ -629,7 +629,9 @@ QRect QPlatformWindow::initialGeometry(const QWindow *w,
         const qreal factor = QHighDpiScaling::factor(w);
         const QSize size = fixInitialSize(QHighDpi::fromNative(initialGeometry.size(), factor),
                                           w, defaultWidth, defaultHeight);
-        return QRect(initialGeometry.topLeft(), QHighDpi::toNative(size, factor));
+        QRect r= QRect(initialGeometry.topLeft(), QHighDpi::toNative(size, factor));
+        qDebug() << __FUNCTION__ << "child" << r;
+        return r;
     }
     const QScreen *screen = effectiveScreen(w);
     if (!screen)
@@ -653,7 +655,9 @@ QRect QPlatformWindow::initialGeometry(const QWindow *w,
             }
         }
     }
-    return QHighDpi::toNativePixels(rect, screen);
+    QRect r= QHighDpi::toNativePixels(rect, screen);
+    qDebug() << __FUNCTION__ << "topl" << r;
+    return r;
 }
 
 /*!
diff --git a/src/gui/kernel/qwindow.cpp b/src/gui/kernel/qwindow.cpp
index cf4a75dfce..74fa894b24 100644
--- a/src/gui/kernel/qwindow.cpp
+++ b/src/gui/kernel/qwindow.cpp
@@ -524,6 +524,8 @@ QWindow::SurfaceType QWindow::surfaceType() const
 void QWindow::setVisible(bool visible)
 {
     Q_D(QWindow);
+    qDebug() << __FUNCTION__ << this << visible << "geom=" << geometry() << "plat=" << d->platformWindow;
+
 
     if (d->visible != visible) {
         d->visible = visible;
@@ -1566,6 +1568,7 @@ void QWindow::setGeometry(int posx, int posy, int w, int h)
 void QWindow::setGeometry(const QRect &rect)
 {
     Q_D(QWindow);
+    qDebug() << __FUNCTION__ << this << rect << "plat=" << d->platformWindow;
     d->positionAutomatic = false;
     const QRect oldRect = geometry();
     if (rect == oldRect)
diff --git a/src/gui/kernel/qwindowsysteminterface.cpp b/src/gui/kernel/qwindowsysteminterface.cpp
index b8299e2cb8..e73ba1f8f7 100644
--- a/src/gui/kernel/qwindowsysteminterface.cpp
+++ b/src/gui/kernel/qwindowsysteminterface.cpp
@@ -278,6 +278,8 @@ void QWindowSystemInterface::handleApplicationStateChanged(Qt::ApplicationState
  */
 QT_DEFINE_QPA_EVENT_HANDLER(void, handleGeometryChange, QWindow *window, const QRect &newRect, const QRect &oldRect)
 {
+    qDebug() << __FUNCTION__ << window << oldRect << "=>" << newRect;
+
     QWindowSystemInterfacePrivate::GeometryChangeEvent *e = new QWindowSystemInterfacePrivate::GeometryChangeEvent(window, QHighDpi::fromNativePixels(newRect, window), QHighDpi::fromNativePixels(oldRect, window));
     QWindowSystemInterfacePrivate::handleWindowSystemEvent<Delivery>(e);
 }
diff --git a/src/plugins/platforms/windows/qwindowsintegration.cpp b/src/plugins/platforms/windows/qwindowsintegration.cpp
index 17cab69891..ef0a75df64 100644
--- a/src/plugins/platforms/windows/qwindowsintegration.cpp
+++ b/src/plugins/platforms/windows/qwindowsintegration.cpp
@@ -320,7 +320,7 @@ QPlatformWindow *QWindowsIntegration::createPlatformWindow(QWindow *window) cons
     QWindowsWindowData obtained =
         QWindowsWindowData::create(window, requested,
                                    QWindowsWindow::formatWindowTitle(window->title()));
-    qCDebug(lcQpaWindows).nospace()
+    qDebug().nospace()
         << __FUNCTION__ << ' ' << window
         << "\n    Requested: " << requested.geometry << " frame incl.="
         << QWindowsGeometryHint::positionIncludesFrame(window)
@@ -342,6 +342,7 @@ QPlatformWindow *QWindowsIntegration::createPlatformWindow(QWindow *window) cons
         const Qt::WindowState state = window->windowState();
         if (state != Qt::WindowMaximized && state != Qt::WindowFullScreen
             && requested.geometry != obtained.geometry) {
+            qDebug() << __FUNCTION__ << "calling handleGeometryChange";
             QWindowSystemInterface::handleGeometryChange(window, obtained.geometry);
         }
         QPlatformScreen *screen = result->screenForGeometry(obtained.geometry);
diff --git a/src/plugins/platforms/windows/qwindowswindow.cpp b/src/plugins/platforms/windows/qwindowswindow.cpp
index 3c79c8aefe..afec9371b9 100644
--- a/src/plugins/platforms/windows/qwindowswindow.cpp
+++ b/src/plugins/platforms/windows/qwindowswindow.cpp
@@ -619,7 +619,7 @@ QWindowsWindowData
     const QWindowCreationContextPtr context(new QWindowCreationContext(w, rect, data.customMargins, style, exStyle));
     QWindowsContext::instance()->setWindowCreationContext(context);
 
-    qCDebug(lcQpaWindows).nospace()
+    qDebug().nospace()
         << "CreateWindowEx: " << w << " class=" << windowClassName << " title=" << title
         << '\n' << *this << "\nrequested: " << rect << ": "
         << context->frameWidth << 'x' <<  context->frameHeight
@@ -631,7 +631,7 @@ QWindowsWindowData
                                  context->frameX, context->frameY,
                                  context->frameWidth, context->frameHeight,
                                  parentHandle, NULL, appinst, NULL);
-    qCDebug(lcQpaWindows).nospace()
+    qDebug().nospace()
         << "CreateWindowEx: returns " << w << ' ' << result.hwnd << " obtained geometry: "
         << context->obtainedGeometry << ' ' << context->margins;
 
@@ -1455,6 +1455,7 @@ QRect QWindowsWindow::normalGeometry() const
 
 void QWindowsWindow::setGeometry(const QRect &rectIn)
 {
+    qDebug() << '>' << __FUNCTION__ << window() << rectIn;
     QRect rect = rectIn;
     // This means it is a call from QWindow::setFramePosition() and
     // the coordinates include the frame (size is still the contents rectangle).
@@ -1561,7 +1562,7 @@ void QWindowsBaseWindow::setGeometry_sys(const QRect &rect) const
     const QMargins margins = frameMargins();
     const QRect frameGeometry = rect + margins;
 
-    qCDebug(lcQpaWindows) << '>' << __FUNCTION__ << window()
+    qDebug() << '>' << __FUNCTION__ << window()
         << "\n from " << geometry_sys() << " frame: "
         << margins << " to " <<rect
         << " new frame: " << frameGeometry;