diff --git a/src/gui/kernel/qguiapplication.cpp b/src/gui/kernel/qguiapplication.cpp
index f43329afd0..b670ca85b0 100644
--- a/src/gui/kernel/qguiapplication.cpp
+++ b/src/gui/kernel/qguiapplication.cpp
@@ -3501,6 +3501,7 @@ QCursor *QGuiApplication::overrideCursor()
  */
 void QGuiApplication::changeOverrideCursor(const QCursor &cursor)
 {
+    qDebug() << __FUNCTION__ << cursor;
     CHECK_QAPP_INSTANCE()
     if (qGuiApp->d_func()->cursor_list.isEmpty())
         return;
@@ -3576,6 +3577,7 @@ static inline void applyWindowCursor(const QList<QWindow *> &l)
 */
 void QGuiApplication::setOverrideCursor(const QCursor &cursor)
 {
+    qDebug() << __FUNCTION__ << cursor << "stacksize=" << qGuiApp->d_func()->cursor_list.size();
     CHECK_QAPP_INSTANCE()
     qGuiApp->d_func()->cursor_list.prepend(cursor);
     applyCursor(QGuiApplicationPrivate::window_list, cursor);
@@ -3594,6 +3596,7 @@ void QGuiApplication::setOverrideCursor(const QCursor &cursor)
 */
 void QGuiApplication::restoreOverrideCursor()
 {
+    qDebug() << __FUNCTION__ << "stacksize=" << qGuiApp->d_func()->cursor_list.size();
     CHECK_QAPP_INSTANCE()
     if (qGuiApp->d_func()->cursor_list.isEmpty())
         return;
diff --git a/src/plugins/platforms/windows/qwindowscursor.cpp b/src/plugins/platforms/windows/qwindowscursor.cpp
index 0a09b87ba3..aad3300e7d 100644
--- a/src/plugins/platforms/windows/qwindowscursor.cpp
+++ b/src/plugins/platforms/windows/qwindowscursor.cpp
@@ -542,8 +542,10 @@ CursorHandlePtr QWindowsCursor::standardWindowCursor(Qt::CursorShape shape)
 {
     StandardCursorCache::Iterator it = m_standardCursorCache.find(shape);
     if (it == m_standardCursorCache.end()) {
-        if (const HCURSOR hc = QWindowsCursor::createCursorFromShape(shape, m_screen))
+        if (const HCURSOR hc = QWindowsCursor::createCursorFromShape(shape, m_screen)) {
+            qDebug() << __FUNCTION__ << shape << hc;
             it = m_standardCursorCache.insert(shape, CursorHandlePtr(new CursorHandle(hc)));
+        }
     }
     return it != m_standardCursorCache.end() ? it.value() : CursorHandlePtr(new CursorHandle);
 }
@@ -595,6 +597,10 @@ QWindowsCursor::QWindowsCursor(const QPlatformScreen *screen)
 
 void QWindowsCursor::changeCursor(QCursor *cursorIn, QWindow *window)
 {
+    if (cursorIn)
+        qDebug().noquote() << __FUNCTION__ << m_screen->name() << *cursorIn << window;
+    else
+        qDebug().noquote() << __FUNCTION__ << m_screen->name() << "null" << window;
     QWindowsWindow *platformWindow = QWindowsWindow::windowsWindowOf(window);
     if (!platformWindow) // Desktop/Foreign window.
         return;
diff --git a/src/plugins/platforms/windows/qwindowswindow.cpp b/src/plugins/platforms/windows/qwindowswindow.cpp
index 402009c70d..936d2758b6 100644
--- a/src/plugins/platforms/windows/qwindowswindow.cpp
+++ b/src/plugins/platforms/windows/qwindowswindow.cpp
@@ -2261,15 +2261,18 @@ static inline bool applyNewCursor(const QWindow *w)
 
 void QWindowsWindow::applyCursor()
 {
+    qDebug() << __FUNCTION__ << window();
 #ifndef QT_NO_CURSOR
     if (m_cursor->isNull()) { // Recurse up to parent with non-null cursor. Set default for toplevel.
         if (const QWindow *p = window()->parent()) {
             if (QWindowsWindow *platformWindow = QWindowsWindow::windowsWindowOf(p))
                 platformWindow->applyCursor();
         } else {
+            qDebug() << __FUNCTION__ << window() << "SetCursor default(" << defaultCursor(window())->handle();
             SetCursor(defaultCursor(window())->handle());
         }
     } else {
+        qDebug() << __FUNCTION__ << window() << "SetCursor(" << m_cursor->handle();
         SetCursor(m_cursor->handle());
     }
 #endif
@@ -2278,9 +2281,10 @@ void QWindowsWindow::applyCursor()
 void QWindowsWindow::setCursor(const CursorHandlePtr &c)
 {
 #ifndef QT_NO_CURSOR
+    qDebug() << __FUNCTION__ << window() << c->handle();
     if (c->handle() != m_cursor->handle()) {
         const bool apply = applyNewCursor(window());
-        qCDebug(lcQpaWindows) << window() << __FUNCTION__
+        qDebug() << window() << __FUNCTION__
             << c->handle() << " doApply=" << apply;
         m_cursor = c;
         if (apply)