diff --git a/src/widgets/graphicsview/qgraphicsscene.cpp b/src/widgets/graphicsview/qgraphicsscene.cpp
index 25b77aa02f..1803bc8b9c 100644
--- a/src/widgets/graphicsview/qgraphicsscene.cpp
+++ b/src/widgets/graphicsview/qgraphicsscene.cpp
@@ -3325,6 +3325,10 @@ bool QGraphicsScene::event(QEvent *event)
     Q_D(QGraphicsScene);
 
     switch (event->type()) {
+    case QEvent::MouseButtonPress:
+    case QEvent::MouseButtonRelease:
+    case QEvent::MouseMove:
+        qDebug() << __FUNCTION__ << event;
     case QEvent::GraphicsSceneMousePress:
     case QEvent::GraphicsSceneMouseMove:
     case QEvent::GraphicsSceneMouseRelease:
@@ -3347,6 +3351,8 @@ bool QGraphicsScene::event(QEvent *event)
         break;
     }
 
+
+
     switch (event->type()) {
     case QEvent::GraphicsSceneDragEnter:
         dragEnterEvent(static_cast<QGraphicsSceneDragDropEvent *>(event));
@@ -3403,7 +3409,7 @@ bool QGraphicsScene::event(QEvent *event)
         mouseMoveEvent(mouseEvent);
         break;
     }
-    case QEvent::GraphicsSceneMousePress:
+    case QEvent::GraphicsSceneMousePress:            
         mousePressEvent(static_cast<QGraphicsSceneMouseEvent *>(event));
         break;
     case QEvent::GraphicsSceneMouseRelease:
@@ -4032,6 +4038,7 @@ void QGraphicsScene::keyReleaseEvent(QKeyEvent *keyEvent)
 */
 void QGraphicsScene::mousePressEvent(QGraphicsSceneMouseEvent *mouseEvent)
 {
+    qDebug() << __FUNCTION__ << mouseEvent;
     Q_D(QGraphicsScene);
     if (d->mouseGrabberItems.isEmpty()) {
         // Dispatch hover events
@@ -4057,6 +4064,7 @@ void QGraphicsScene::mousePressEvent(QGraphicsSceneMouseEvent *mouseEvent)
 */
 void QGraphicsScene::mouseMoveEvent(QGraphicsSceneMouseEvent *mouseEvent)
 {
+    qDebug() << __FUNCTION__ << mouseEvent;
     Q_D(QGraphicsScene);
     if (d->mouseGrabberItems.isEmpty()) {
         if (mouseEvent->buttons())
@@ -4087,6 +4095,7 @@ void QGraphicsScene::mouseMoveEvent(QGraphicsSceneMouseEvent *mouseEvent)
 */
 void QGraphicsScene::mouseReleaseEvent(QGraphicsSceneMouseEvent *mouseEvent)
 {
+    qDebug() << __FUNCTION__ << mouseEvent;
     Q_D(QGraphicsScene);
     if (d->mouseGrabberItems.isEmpty()) {
         mouseEvent->ignore();
@@ -5881,6 +5890,7 @@ int QGraphicsScenePrivate::findClosestTouchPointId(const QPointF &scenePos)
 
 void QGraphicsScenePrivate::touchEventHandler(QTouchEvent *sceneTouchEvent)
 {
+    qDebug() << __FUNCTION__ << sceneTouchEvent;
     typedef QPair<Qt::TouchPointStates, QList<QTouchEvent::TouchPoint> > StatesAndTouchPoints;
     QHash<QGraphicsItem *, StatesAndTouchPoints> itemsNeedingEvents;
 
diff --git a/src/widgets/graphicsview/qgraphicsview.cpp b/src/widgets/graphicsview/qgraphicsview.cpp
index 1cc8543fdd..e022bcf13f 100644
--- a/src/widgets/graphicsview/qgraphicsview.cpp
+++ b/src/widgets/graphicsview/qgraphicsview.cpp
@@ -309,14 +309,15 @@ inline int q_round_bound(qreal d) //### (int)(qreal) INT_MAX != INT_MAX for sing
 }
 
 void QGraphicsViewPrivate::translateTouchEvent(QGraphicsViewPrivate *d, QTouchEvent *touchEvent)
-{
+{    
     QList<QTouchEvent::TouchPoint> touchPoints = touchEvent->touchPoints();
     for (int i = 0; i < touchPoints.count(); ++i) {
         QTouchEvent::TouchPoint &touchPoint = touchPoints[i];
         // the scene will set the item local pos, startPos, lastPos, and rect before delivering to
-        // an item, but for now those functions are returning the view's local coordinates
+        // an item, but for now those functions are returning the view's local coordinates        
         touchPoint.setSceneRect(d->mapToScene(touchPoint.rect()));
         touchPoint.setStartScenePos(d->mapToScene(touchPoint.startPos()));
+        qDebug() << __FUNCTION__ << touchPoint.startPos() << "->scene" <<  touchPoint.startScenePos();
         touchPoint.setLastScenePos(d->mapToScene(touchPoint.lastPos()));
 
         // screenPos, startScreenPos, lastScreenPos, and screenRect are already set
@@ -651,6 +652,7 @@ void QGraphicsViewPrivate::mouseMoveEventHandler(QMouseEvent *event)
     mouseEvent.setButtonDownScenePos(mousePressButton, mousePressScenePoint);
     mouseEvent.setButtonDownScreenPos(mousePressButton, mousePressScreenPoint);
     mouseEvent.setScenePos(q->mapToScene(event->pos()));
+    qDebug() << __FUNCTION__ << event->pos() << "-> scene"  << mouseEvent.scenePos();
     mouseEvent.setScreenPos(event->globalPos());
     mouseEvent.setLastScenePos(lastMouseMoveScenePoint);
     mouseEvent.setLastScreenPos(lastMouseMoveScreenPoint);
@@ -2937,6 +2939,7 @@ bool QGraphicsView::viewportEvent(QEvent *event)
             // Convert and deliver the touch event to the scene.
             QTouchEvent *touchEvent = static_cast<QTouchEvent *>(event);
             touchEvent->setTarget(viewport());
+            qDebug() << __FUNCTION__ << touchEvent->target();
             QGraphicsViewPrivate::translateTouchEvent(d, touchEvent);
             (void) QApplication::sendEvent(d->scene, touchEvent);
         } else {
@@ -3235,6 +3238,8 @@ void QGraphicsView::mousePressEvent(QMouseEvent *event)
         // Store some of the event's button-down data.
         d->mousePressViewPoint = event->pos();
         d->mousePressScenePoint = mapToScene(d->mousePressViewPoint);
+        qDebug() << __FUNCTION__ << "setting mousePressScenePoint=" << d->mousePressScenePoint << "from "
+                 << event->pos();
         d->mousePressScreenPoint = event->globalPos();
         d->lastMouseMoveScenePoint = d->mousePressScenePoint;
         d->lastMouseMoveScreenPoint = d->mousePressScreenPoint;
@@ -3247,6 +3252,7 @@ void QGraphicsView::mousePressEvent(QMouseEvent *event)
             mouseEvent.setButtonDownScenePos(d->mousePressButton, d->mousePressScenePoint);
             mouseEvent.setButtonDownScreenPos(d->mousePressButton, d->mousePressScreenPoint);
             mouseEvent.setScenePos(d->mousePressScenePoint);
+            qDebug() << __FUNCTION__ << "d->mousePressScenePoint: "  << d->mousePressScenePoint;
             mouseEvent.setScreenPos(d->mousePressScreenPoint);
             mouseEvent.setLastScenePos(d->lastMouseMoveScenePoint);
             mouseEvent.setLastScreenPos(d->lastMouseMoveScreenPoint);
@@ -3381,8 +3387,9 @@ void QGraphicsView::mouseReleaseEvent(QMouseEvent *event)
     QGraphicsSceneMouseEvent mouseEvent(QEvent::GraphicsSceneMouseRelease);
     mouseEvent.setWidget(viewport());
     mouseEvent.setButtonDownScenePos(d->mousePressButton, d->mousePressScenePoint);
-    mouseEvent.setButtonDownScreenPos(d->mousePressButton, d->mousePressScreenPoint);
+    mouseEvent.setButtonDownScreenPos(d->mousePressButton, d->mousePressScreenPoint);    
     mouseEvent.setScenePos(mapToScene(event->pos()));
+    qDebug() << __FUNCTION__ << event->pos() << "-> scene"  << mouseEvent.scenePos();
     mouseEvent.setScreenPos(event->globalPos());
     mouseEvent.setLastScenePos(d->lastMouseMoveScenePoint);
     mouseEvent.setLastScreenPos(d->lastMouseMoveScreenPoint);