diff --git a/sources/pyside2/doc/CMakeLists.txt b/sources/pyside2/doc/CMakeLists.txt
index 326e5ae7..cf49d99b 100644
--- a/sources/pyside2/doc/CMakeLists.txt
+++ b/sources/pyside2/doc/CMakeLists.txt
@@ -76,6 +76,8 @@ add_custom_target(qdoc
                 COMMENT "Running qdoc against Qt source code..."
                 SOURCE "pyside.qdocconf")
 
+message(STATUS "SPHINX CALL: ${SHIBOKEN_PYTHON_INTERPRETER} ${SPHINX_BUILD} -b html  ${CMAKE_CURRENT_BINARY_DIR}/rst html")
+
 add_custom_target(apidoc
                   COMMAND ${CMAKE_COMMAND} -E copy_directory ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR}/rst
                   COMMAND ${SHIBOKEN_PYTHON_INTERPRETER} ${SPHINX_BUILD} -b html  ${CMAKE_CURRENT_BINARY_DIR}/rst html
diff --git a/sources/pyside2/doc/inheritance_diagram.py b/sources/pyside2/doc/inheritance_diagram.py
index cd49906a..471d82ca 100644
--- a/sources/pyside2/doc/inheritance_diagram.py
+++ b/sources/pyside2/doc/inheritance_diagram.py
@@ -75,10 +75,12 @@ class InheritanceGraph(object):
         If *show_builtins* is True, then Python builtins will be shown
         in the graph.
         """
+        print('InheritanceGraph:__init__ currmodule=', currmodule, "class_names=", class_names)
         self.class_names = class_names
         classes = self._import_classes(class_names, currmodule)
         self.class_info = self._class_info(classes, show_builtins, parts)
         if not self.class_info:
+            print('InheritanceGraph:__init__ no classes')
             raise InheritanceException('No classes found for '
                                        'inheritance diagram')
 
@@ -99,6 +101,7 @@ class InheritanceGraph(object):
         try:
             __import__(fullname)
             todoc = sys.modules[fullname]
+            print('_import_class_or_module m1: ', fullname, "todoc=", todoc)
         except ImportError:
             # else it is a class, then import the module
             if not path:
@@ -112,6 +115,7 @@ class InheritanceGraph(object):
             try:
                 __import__(path)
                 todoc = getattr(sys.modules[path], base)
+                print('_import_class_or_module m2: ', path, "todoc=", todoc)
             except (ImportError, AttributeError):
                 raise InheritanceException(
                     'Could not import class or module %r specified for '
@@ -119,21 +123,26 @@ class InheritanceGraph(object):
 
         # If a class, just return it
         if inspect.isclass(todoc):
+            print('_import_class_or_module isclass')
             return [todoc]
         elif inspect.ismodule(todoc):
+            print('_import_class_or_module ismodule')
             classes = []
             for cls in todoc.__dict__.values():
                 if inspect.isclass(cls) and cls.__module__ == todoc.__name__:
                     classes.append(cls)
+            print('_import_class_or_module module classes', classes)
             return classes
         raise InheritanceException('%r specified for inheritance diagram is '
                                    'not a class or module' % name)
 
     def _import_classes(self, class_names, currmodule):
         """Import a list of classes."""
+        print('_import_classes currmodule=', currmodule, class_names)
         classes = []
         for name in class_names:
             classes.extend(self._import_class_or_module(name, currmodule))
+        print('_import_classes returns ', classes)
         return classes
 
     def _class_info(self, classes, show_builtins, parts):
@@ -143,6 +152,7 @@ class InheritanceGraph(object):
         *parts* gives the number of dotted name parts that is removed from the
         displayed node names.
         """
+        print('_class_info', classes, show_builtins)
         all_classes = {}
         builtins = __builtins__.values()
 
@@ -175,6 +185,7 @@ class InheritanceGraph(object):
         This works for things I've tested in matplotlib so far, but may not be
         completely general.
         """
+        print('class_name', cls)
         module = cls.__module__
         if module == '__builtin__':
             fullname = cls.__name__
@@ -183,12 +194,14 @@ class InheritanceGraph(object):
         if parts == 0:
             return fullname
         name_parts = fullname.split('.')
+        print('class_name returns', name_parts)
         return '.'.join(name_parts[-parts:])
 
     def get_all_class_names(self):
         """
         Get all of the class names involved in the graph.
         """
+        print('get_all_class_names')
         return [fullname for (_, fullname, _) in self.class_info]
 
     # These are the default attrs for graphviz
@@ -228,6 +241,8 @@ class InheritanceGraph(object):
         *graph_attrs*, *node_attrs*, *edge_attrs* are dictionaries containing
         key/value pairs to pass on as graphviz properties.
         """
+
+        print('inheritance_diagram.py: generate_dot')
         g_attrs = self.default_graph_attrs.copy()
         n_attrs = self.default_node_attrs.copy()
         e_attrs = self.default_edge_attrs.copy()
@@ -244,6 +259,7 @@ class InheritanceGraph(object):
         res.append(self._format_graph_attrs(g_attrs))
 
         for name, fullname, bases in self.class_info:
+            print('inheritance_diagram.py: looping', name, fullname, bases)
             # Write the node
             this_node_attrs = n_attrs.copy()
             url = urls.get(fullname)
@@ -281,11 +297,14 @@ class InheritanceDiagram(Directive):
     }
 
     def run(self):
+        print('inheritance_diagram.py: run')
         node = inheritance_diagram()
         node.document = self.state.document
         env = self.state.document.settings.env
         class_names = self.arguments[0].split()
+        print('inheritance_diagram.py', class_names)
         class_role = env.get_domain('py').role('class')
+        print('inheritance_diagram.py:run', class_names, 'role=', class_role)
         # Store the original content for use as a hash
         node['parts'] = self.options.get('parts', 0)
         node['content'] = ', '.join(class_names)
@@ -295,7 +314,9 @@ class InheritanceDiagram(Directive):
             graph = InheritanceGraph(
                 class_names, env.temp_data.get('py:module'),
                 parts=node['parts'])
+            print('inheritance_diagram.py: got graph')
         except InheritanceException as err:
+            print('inheritance_diagram.py: InheritanceException')
             return [node.document.reporter.warning(err.args[0],
                                                    line=self.lineno)]
 
@@ -323,6 +344,7 @@ def html_visit_inheritance_diagram(self, node):
     Output the graph for HTML.  This will insert a PNG with clickable
     image map.
     """
+    print('inheritance_diagram.py: html_visit_inheritance_diagram')
     graph = node['graph']
 
     graph_hash = get_graph_hash(node)
@@ -346,6 +368,7 @@ def latex_visit_inheritance_diagram(self, node):
     """
     Output the graph for LaTeX.  This will insert a PDF.
     """
+    print('inheritance_diagram.py:latex_visit_inheritance_diagram')
     graph = node['graph']
 
     graph_hash = get_graph_hash(node)
@@ -362,6 +385,7 @@ def skip(self, node):
 
 
 def setup(app):
+    print('inheritance_diagram.py: setup')
     app.setup_extension('sphinx.ext.graphviz')
     app.add_node(
         inheritance_diagram,
@@ -369,7 +393,12 @@ def setup(app):
         html=(html_visit_inheritance_diagram, None),
         text=(skip, None),
         man=(skip, None))
+    print('inheritance_diagram.py: setup added node')
     app.add_directive('inheritance-diagram', InheritanceDiagram)
+    print('inheritance_diagram.py: setup added directive')
     app.add_config_value('inheritance_graph_attrs', {}, False),
+    print('inheritance_diagram.py: setup added inheritance_graph_attrs')
     app.add_config_value('inheritance_node_attrs', {}, False),
+    print('inheritance_diagram.py: setup added inheritance_node_attrs')
     app.add_config_value('inheritance_edge_attrs', {}, False),
+    print('inheritance_diagram.py: setup added inheritance_edge_attrs, done')
diff --git a/sources/shiboken2/generator/qtdoc/qtdocgenerator.cpp b/sources/shiboken2/generator/qtdoc/qtdocgenerator.cpp
index fb4de46d..9160a4fd 100644
--- a/sources/shiboken2/generator/qtdoc/qtdocgenerator.cpp
+++ b/sources/shiboken2/generator/qtdoc/qtdocgenerator.cpp
@@ -1323,7 +1323,7 @@ void QtDocGenerator::generateClass(QTextStream &s, GeneratorContext &classContex
     s << className << endl;
     s << Pad('*', className.count()) << endl << endl;
 
-    s << ".. inheritance-diagram:: " << className << endl
+    s << ".. inheritance-diagram:: " << metaClass->fullName() << endl
       << "    :parts: 2" << endl << endl; // TODO: This would be a parameter in the future...
 
 