diff --git a/src/designer/src/components/propertyeditor/propertyeditor.cpp b/src/designer/src/components/propertyeditor/propertyeditor.cpp
index 2fc1ff41..123b6e24 100644
--- a/src/designer/src/components/propertyeditor/propertyeditor.cpp
+++ b/src/designer/src/components/propertyeditor/propertyeditor.cpp
@@ -905,12 +905,14 @@ static QString msgUnsupportedType(const QString &propertyName, int type)
 
 void PropertyEditor::setObject(QObject *object)
 {
+    qDebug() << "PropertyEditor::setObject" << object;
     QDesignerFormWindowInterface *oldFormWindow = QDesignerFormWindowInterface::findFormWindow(m_object);
     // In the first setObject() call following the addition of a dynamic property, focus and edit it.
     const bool editNewDynamicProperty = object != 0 && m_object == object && !m_recentlyAddedDynamicProperty.isEmpty();
     m_object = object;
     m_propertyManager->setObject(object);
     QDesignerFormWindowInterface *formWindow = QDesignerFormWindowInterface::findFormWindow(m_object);
+    qDebug() << "PropertyEditor::setObject , formWindow=" << formWindow;
     FormWindowBase *fwb = qobject_cast<FormWindowBase *>(formWindow);
     const bool idIdBasedTranslation = fwb && fwb->useIdBasedTranslations();
     const bool idIdBasedTranslationUnchanged = (idIdBasedTranslation == DesignerPropertyManager::useIdBasedTranslations());
diff --git a/src/designer/src/lib/shared/morphmenu.cpp b/src/designer/src/lib/shared/morphmenu.cpp
index 226f7e9f..8a8b1da3 100644
--- a/src/designer/src/lib/shared/morphmenu.cpp
+++ b/src/designer/src/lib/shared/morphmenu.cpp
@@ -284,6 +284,7 @@ private:
 
 bool MorphWidgetCommand::addMorphMacro(QDesignerFormWindowInterface *fw, QWidget *w, const QString &newClass)
 {
+    qDebug() << __FUNCTION__ << w << newClass;
     MorphWidgetCommand *morphCmd = new MorphWidgetCommand(fw);
     if (!morphCmd->init(w, newClass)) {
         qWarning("*** Unable to create a MorphWidgetCommand");
@@ -291,6 +292,7 @@ bool MorphWidgetCommand::addMorphMacro(QDesignerFormWindowInterface *fw, QWidget
         return false;
     }
     QLabel *buddyLabel = buddyLabelOf(fw, w);
+    qDebug() << __FUNCTION__ << "buddyLabel=" << buddyLabel;
     // Need a macro since it adds further commands
     QUndoStack *us = fw->commandHistory();
     us->beginMacro(morphCmd->text());
@@ -299,10 +301,12 @@ bool MorphWidgetCommand::addMorphMacro(QDesignerFormWindowInterface *fw, QWidget
         fwb->emitWidgetRemoved(w);
 
     const QString newWidgetName = morphCmd->newWidgetName();
+    qDebug() << __FUNCTION__ << "newWidgetName=" << newWidgetName;
     us->push(morphCmd);
 
     // restore buddy using the QByteArray name.
     if (buddyLabel) {
+        qDebug() << __FUNCTION__ << "buddyLabel=" << buddyLabel;
         SetPropertyCommand *buddyCmd = new SetPropertyCommand(fw);
         buddyCmd->init(buddyLabel, QStringLiteral("buddy"), QVariant(newWidgetName.toUtf8()));
         us->push(buddyCmd);
@@ -386,6 +390,7 @@ bool MorphWidgetCommand::init(QWidget *widget, const QString &newClassName)
 
 void MorphWidgetCommand::redo()
 {
+    qDebug() << "MorphWidgetCommand::redo";
     morph(m_beforeWidget, m_afterWidget);
 }
 
@@ -396,6 +401,7 @@ void  MorphWidgetCommand::undo()
 
 void MorphWidgetCommand::morph(QWidget *before, QWidget *after)
 {
+    qDebug() << __FUNCTION__ << "before=" << before << "after=" << after;
     QDesignerFormWindowInterface *fw = formWindow();
 
     fw->unmanageWidget(before);
diff --git a/src/designer/src/lib/shared/qdesigner_propertycommand.cpp b/src/designer/src/lib/shared/qdesigner_propertycommand.cpp
index 43da500a..2bfb8f6e 100644
--- a/src/designer/src/lib/shared/qdesigner_propertycommand.cpp
+++ b/src/designer/src/lib/shared/qdesigner_propertycommand.cpp
@@ -1166,6 +1166,7 @@ void PropertyListCommand::update(unsigned updateMask)
         // the child is the active widget,
         // TODO: current object?
         if (QDesignerPropertyEditorInterface *propertyEditor = formWindow()->core()->propertyEditor()) {
+            qDebug() << __FUNCTION__ << propertyEditor->object();
             propertyEditor->setObject(propertyEditor->object());
         }
     }
@@ -1201,6 +1202,7 @@ SetPropertyCommand::SetPropertyCommand(QDesignerFormWindowInterface *formWindow,
 
 bool SetPropertyCommand::init(QObject *object, const QString &apropertyName, const QVariant &newValue)
 {
+    qDebug() << "SetPropertyCommand::init" << object <<  apropertyName << newValue;
     Q_ASSERT(object);
 
     m_newValue = newValue;
@@ -1259,8 +1261,10 @@ void SetPropertyCommand::setDescription()
 
 void SetPropertyCommand::redo()
 {
+    qDebug() << "SetPropertyCommand::redo";
     update(setValue(m_newValue, true, m_subPropertyMask));
     QDesignerPropertyEditor *designerPropertyEditor = qobject_cast<QDesignerPropertyEditor *>(core()->propertyEditor());
+    qDebug() << __FUNCTION__ << m_newValue;
     if (designerPropertyEditor)
         designerPropertyEditor->updatePropertySheet();
 }